require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to test the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator. If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails. There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.

RSpec.describe '/meth/list_contents', type: :request do
  let(:valid_attributes) { FactoryBot.attributes_for(:meth_list_content, custom_field_desc_id: custom_field_desc.id) }
  let(:invalid_attributes) { FactoryBot.attributes_for(:meth_list_content, name: '', custom_field_desc_id: custom_field_desc.id) }

  let(:custom_field_desc) { FactoryBot.create(:meth_custom_field_desc, custom_field_type: custom_field_type) }
  let(:custom_field_type) { FactoryBot.create(:meth_custom_field_type, :type_select) }

  let(:user) { FactoryBot.create(:user) }
  let(:methodology) { FactoryBot.create(:methodology, :with_step_1) }

  before :each do
    user.set_session(:active_step_tool, methodology.steps.first.step_tools.first.id)
    user.save!
    sign_in user
  end

  describe 'GET /index' do
    it 'renders a successful response' do
      Meth::ListContent.create! valid_attributes
      get meth_list_contents_url
      expect(response).to be_successful
    end
  end

  describe 'GET /show' do
    it 'renders a successful response' do
      meth_list_content = Meth::ListContent.create! valid_attributes
      get meth_list_content_url(meth_list_content)
      expect(response).to be_successful
    end
  end

  describe 'GET /new' do
    context 'without params' do
      it 'renders a successful response' do
        get new_meth_list_content_url, xhr: true
        expect(response).to be_successful
      end
    end
    context 'with params' do
      it 'renders a successful response' do
        get new_meth_list_content_url(meth_list_content: {custom_field_desc_id: custom_field_desc.id,
                                                          pos: custom_field_desc.list_contents.size + 1}), xhr: true
        expect(@controller.instance_variable_get(:@list_content).pos).to eq 1
        expect(@controller.instance_variable_get(:@list_content).custom_field_desc_id).to eq custom_field_desc.id
        expect(response).to be_successful
      end
    end
  end

  describe 'GET /edit' do
    it 'render a successful response' do
      meth_list_content = Meth::ListContent.create! valid_attributes
      get edit_meth_list_content_url(meth_list_content)
      expect(response).to be_successful
    end
  end

  describe 'POST /create' do
    context 'with valid parameters' do
      it 'creates a new Meth::ListContent' do
        expect {
          post meth_list_contents_url, params: { meth_list_content: valid_attributes }, xhr: true
        }.to change(Meth::ListContent, :count).by(1)
      end

      it 'render (js) list with list_content created' do
        post meth_list_contents_url, params: { meth_list_content: valid_attributes }, xhr: true
        # expect(response).to redirect_to(meth_list_content_url(@meth_list_content))
        expect(response).to be_successful
      end
    end

    context 'with invalid parameters' do
      it 'does not create a new Meth::ListContent' do
        expect {
          post meth_list_contents_url, params: { meth_list_content: invalid_attributes }
        }.to change(Meth::ListContent, :count).by(0)
      end

      it 'renders a successful response (i.e. to display the new template)' do
        post meth_list_contents_url, params: { meth_list_content: invalid_attributes }
        expect(response).to be_successful
      end
    end
  end

  describe 'PATCH /update' do
    context 'with valid parameters' do
      let(:new_attributes) { {name: 'list content new name'} }

      it 'updates the requested meth_list_content' do
        meth_list_content = Meth::ListContent.create! valid_attributes
        patch meth_list_content_url(meth_list_content), params: { meth_list_content: new_attributes }
        meth_list_content.reload
        expect(meth_list_content.name).to eq 'list content new name'
      end

      it 'redirects to the meth_list_content' do
        meth_list_content = Meth::ListContent.create! valid_attributes
        patch meth_list_content_url(meth_list_content), params: { meth_list_content: new_attributes }
        meth_list_content.reload
        expect(response).to redirect_to(meth_list_content_url(meth_list_content))
      end
    end

    context 'with invalid parameters' do
      it 'renders a successful response (i.e. to display the edit template)' do
        meth_list_content = Meth::ListContent.create! valid_attributes
        patch meth_list_content_url(meth_list_content), params: { meth_list_content: invalid_attributes }
        expect(response).to be_successful
      end
    end
  end

  describe 'DELETE /destroy' do
    it 'destroys the requested meth_list_content' do
      meth_list_content = Meth::ListContent.create! valid_attributes
      expect {
        delete meth_list_content_url(meth_list_content)
      }.to change(Meth::ListContent, :count).by(-1)
    end

    it 'redirects to the meth_list_contents list' do
      meth_list_content = Meth::ListContent.create! valid_attributes
      delete meth_list_content_url(meth_list_content)
      expect(response).to redirect_to(meth_list_contents_url)
    end
  end

  describe 'PATCH /list_content_up' do
    it 'moves up the custom field' do
      lc1 = Meth::ListContent.create! valid_attributes.merge(pos: 1)
      lc2 = Meth::ListContent.create! valid_attributes.merge(pos: 2)
      lc3 = Meth::ListContent.create! valid_attributes.merge(pos: 3)

      patch meth_list_content_up_path(id: lc1)

      expect(lc1.reload.pos).to eq 2
      expect(lc2.reload.pos).to eq 1
      expect(lc3.reload.pos).to eq 3

      expect(response).to redirect_to(meth_list_contents_path)
    end
  end

  describe 'PATCH /list_content_down' do
    it 'moves down the custom field' do
      lc1 = Meth::ListContent.create! valid_attributes.merge(pos: 1)
      lc2 = Meth::ListContent.create! valid_attributes.merge(pos: 2)
      lc3 = Meth::ListContent.create! valid_attributes.merge(pos: 3)

      patch meth_list_content_down_path(id: lc2)

      expect(lc1.reload.pos).to eq 2
      expect(lc2.reload.pos).to eq 1
      expect(lc3.reload.pos).to eq 3

      expect(response).to redirect_to(meth_list_contents_path)
    end
  end

  describe 'GET /new_from_csv' do
    # context 'without params' do
    #   it 'renders a successful response' do
    #     get meth_list_content_new_from_csv_url, xhr: true
    #     expect(response).to be_successful
    #   end
    # end
    context 'with params' do
      it 'renders a successful response' do
        get meth_list_content_new_from_csv_url(meth_list_content: {custom_field_desc_id: custom_field_desc.id }), xhr: true
        expect(response).to be_successful
      end
    end
  end

  describe 'POST /create_from_csv' do
    context 'with valid parameters' do
      context 'without ID column' do
        it 'creates 3 new Meth::ListContent from CSV' do
          expect {
            post meth_list_content_create_from_csv_url, params: { custom_field_desc_id: custom_field_desc.id,
                                                                  file_csv: 'spec/fixtures/files/test_csv1.csv' }, xhr: true
          }.to change(Meth::ListContent, :count).by(3)
        end
      end
      context 'with ID column' do
        it 'updates 3 Meth::ListContent from CSV' do
          FactoryBot.create(:meth_list_content, custom_field_desc_id: custom_field_desc.id, id: 100)
          FactoryBot.create(:meth_list_content, custom_field_desc_id: custom_field_desc.id, id: 101)
          FactoryBot.create(:meth_list_content, custom_field_desc_id: custom_field_desc.id, id: 102)

          expect {
            post meth_list_content_create_from_csv_url, params: { custom_field_desc_id: custom_field_desc.id,
                                                                  file_csv: 'spec/fixtures/files/test_csv2.csv' }, xhr: true
          }.to change(Meth::ListContent, :count).by(0)
        end
      end
      context 'with Dependence (custom field dep)' do
        it 'creates 3 new Meth::ListContent from CSV with dependence' do
          custom_dep = FactoryBot.create(:meth_custom_field_desc, custom_field_type: custom_field_type, internal_name: 'custom_1234')

          expect {
            post meth_list_content_create_from_csv_url, params: { custom_field_desc_id: custom_field_desc.id,
                                                                  file_csv: 'spec/fixtures/files/test_csv3.csv' }, xhr: true
          }.to change(Meth::ListContent, :count).by(3)

          expect(custom_field_desc.reload.ref_field).to eq custom_dep
        end
      end

      it 'redirect to meth_list_contents_url' do
        post meth_list_content_create_from_csv_url, params: { custom_field_desc_id: custom_field_desc.id,
                                                              file_csv: 'spec/fixtures/files/test_csv1.csv' }, xhr: true

        expect(response).to redirect_to(meth_list_contents_url)
      end
    end
    context 'with invalid parameters' do
      it 'creates nothing' do
        expect {
          post meth_list_content_create_from_csv_url, params: { custom_field_desc_id: custom_field_desc.id,
                                                                file_csv: 'toto.csv' }, xhr: true
        }.to change(Meth::ListContent, :count).by(0)
      end

      it 'redirect to meth_list_contents_url' do
        post meth_list_content_create_from_csv_url, params: { custom_field_desc_id: custom_field_desc.id,
                                                              file_csv: 'toto.csv' }, xhr: true

        expect(response).to redirect_to(meth_list_contents_url)
      end
    end
  end

  # describe 'GET /export_csv' do
  #   context 'with Dependencies' do
  #     it 'creates csv file with dependencies' do
  #       custom_dep = FactoryBot.create(:meth_custom_field_desc, custom_field_type: custom_field_type, internal_name: 'custom_1234')
  #       post meth_list_content_create_from_csv_url, params: { custom_field_desc_id: custom_field_desc.id,
  #                                                             file_csv: 'spec/fixtures/files/test_csv3.csv' }, xhr: true
  #       expect(custom_field_desc.reload.ref_field).to eq custom_dep

  #       get meth_list_content_export_csv_url, params: { custom_field_desc_id: custom_field_desc.id,
  #                                                       file_csv: 'spec/fixtures/files/test_csv3.csv' }
  #       f_source = File.read('spec/fixtures/files/test_csv3.csv')
  #       expect(response.body).to eq f_source
  #     end
  #   end
  # end
end
